<?
// bei der Konfiguration unbedingt auf die Gro/Kleinschreibung achten

Global $CfgDaten; // damit kann der Script auch von anderen Scripten aufgerufen werden und bereits mit CfgDaten vorkonfiguriert werden
// RS-Special: Konfig/externe Daten --------------------------------------------
   include 							  "HC RS.Special externe Daten.ips.php";
	// RS Farbarray aufrufen
		//print_r($Farb_Array);

	// Array Sonnenstand Forecast heute
		//print_r($SolarData);

   //Sonnenstand-Maximum pro Tag (1Jahr) laden
	$Solar_max_File 					= IPS_GetKernelDir() . "webfront\user\astro\Sonnenstand_max_Jahr.tmp";  	// fr jede ScriptID wird eine eigene Tmp-Datei erzeugt

	$max_file = file ($Solar_max_File);
   $max_raw = array();

	$max_raw = explode(chr(13),$max_file[0]);
	$Solar_maxData  = array();
	for($i = 0;($i < count($max_raw)-1) && ($i < 400); $i++)
	{
	   $max_split = explode(",", $max_raw[$i]);
	   $Solar_maxData[$i]['TimeStamp'] 		= $max_split[2];  // Key [2] = Tages-Timestamp 0:00 Uhr
	   //$Solar_maxData[$i]['DateTimeStamp'] = date("d.m.Y H:i", $max_split[0]);
	   $Solar_maxData[$i]['humanDate'] 			= date("H:i:s, d.m.Y", $Solar_maxData[$i]['TimeStamp']);
	   $Solar_maxData[$i]['Value'] 			= mktime(date("H", $max_split[0]), date("i", $max_split[0]), date("s", $max_split[0]), 1, 1, 2012) *1000;
	   $Solar_maxData[$i]['Value_humanDate'] 			= date("H:i:s, d.m.Y", $Solar_maxData[$i]['Value']/1000);
	}
	//print_r($Solar_maxData);

// RS-Special: Ende ------------------------------------------------------------



//################# Konfig Ende ################################################

	$CfgDaten['Ips']['ChartType'] 							= 'Highcharts'; //"HighCharts" oder "Highstock" auswhlen


	// IPS Variablen IDs
	$CfgDaten["ContentVarableId"]								= -1;  // ID der String Variable in welche die Daten geschrieben werden (-1 oder berhaupt nicht angeben wenn die Content Variable das bergordnete Element ist)
	$CfgDaten["HighChartScriptId"]							= 35562 /*[HighCarts\HighCharts  2.02]*/ ;  				// ID des Highcharts Scripts

	// Zeitraum welcher dargestellt werden soll
	$CfgDaten["StartTime"] 										= mktime(0,0,0, date("m", time()), 1, date("Y",time())-1);
	$CfgDaten["EndTime"] 										= mktime(23,59,59, date("m", time()), date("d",time()), date("Y",time()));
	$ts_yet  														= date("(D) d.m.Y H:i", $CfgDaten["StartTime"]);
	$te_yet  														= date("(D) d.m.Y H:i", time());
	// berschriften
	$CfgDaten['title']['text'] 								= "";
	$CfgDaten['title']['text'] 								= NULL;
	$CfgDaten['subtitle']['text'] 							= "Zeitraum: $ts_yet - $te_yet"; // "" = Automatisch ber Zeitraum
	$CfgDaten['subtitle']['Ips']['DateTimeFormat'] 		= "(D) d.m.Y H:i"; 			// z.B.: "(D) d.m.Y H:i" (wird auch als Default herangezogen wenn nichts konfiguriert wurde)

	// damit wird die Art des Aufrufes festgelegt
	$CfgDaten["RunMode"] 										= "file"; 	// file, script oder popup
	if ($CfgDaten["RunMode"] 									== "popup")
	{
		$CfgDaten["WebFrontConfigId"] 						= NULL;
		$CfgDaten["WFCPopupTitle"] 							= "Ich bin der Text, welcher als berschrift im Popup gezeigt wird";
	}

	// Serienbergreifende Einstellung fr das Laden von Werten
	$CfgDaten["AggregatedValues"]["HourValues"] 			= -1;      // ist der Zeitraum grer als X Tage werden Stundenwerte geladen
	$CfgDaten["AggregatedValues"]["DayValues"] 			= 1;       // ist der Zeitraum grer als X Tage werden Tageswerte geladen
	$CfgDaten["AggregatedValues"]["WeekValues"] 			= -1;      // ist der Zeitraum grer als X Tage werden Wochenwerte geladen
	$CfgDaten["AggregatedValues"]["MonthValues"] 		= -1;      // ist der Zeitraum grer als X Tage werden Monatswerte geladen
	$CfgDaten["AggregatedValues"]["YearValues"] 			= -1;      	// ist der Zeitraum grer als X Tage werden Jahreswerte geladen
	$CfgDaten["AggregatedValues"]["NoLoggedValues"] 	= 1000; 	// ist der Zeitraum grer als X Tage werden keine Boolean Werte mehr geladen, diese werden zuvor immer als Einzelwerte geladen	$CfgDaten["AggregatedValues"]["MixedMode"] = false;     // alle Zeitraumbedingungen werden kombiniert
	$CfgDaten["AggregatedValues"]["MixedMode"] 			= false;

	// Sonnenstand
	$serie 															= array(	"Id"=>0,
																					"Data"=>$Solar_maxData,
																					"Name" =>"max. Sonnenstand",
																					"Unit"=>"Uhr",
																					"AggType"=>1,
																					"zIndex"=>20,
																					"AggValue"=>"Avg",
																					"RoundValue"=>2,
																					"ReplaceValues"=>false);
	$serie['type'] 												= "spline";
	$serie['step'] 												= false;
	$serie['yAxis'] 												= 0;
	$serie['visible'] 											= true;
	$serie['showInLegend'] 										= false;
	$serie['color'] 												= $Farb_Array['Sonnenstand'];
	$serie['shadow'] 												= true;
	$serie['lineWidth'] 											= 1;
	$serie['states']['hover']['lineWidth'] 				= 1;
	$serie['marker']['enabled'] 								= false;
	$serie['marker']['symbol'] 								= 'circle';
	$serie['marker']['states']['hover']['enabled'] 		= true;
	$serie['marker']['states']['hover']['symbol'] 		= 'circle';
	$serie['marker']['states']['hover']['radius'] 		= 4;
	$serie['marker']['states']['hover']['lineWidth'] 	= 1;
	$serie['tooltip']['valueDecimals']						= 2;
	$CfgDaten["Series"][] 										= $serie;
	
	// Achsen-Definitionen +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	// Definition Y-Achse 1
	$Ai                                                = 0;
	$CfgDaten["yAxis"][$Ai]['title']['text']				= "";
	$CfgDaten["yAxis"][$Ai]['enabled']						= true;
	$CfgDaten["yAxis"][$Ai]['Unit']							= 'Uhr';
	$CfgDaten["yAxis"][$Ai]['opposite']						= false;
	//$CfgDaten["yAxis"][$Ai]['allowDecimals']				= false;
	$CfgDaten["yAxis"][$Ai]['tickInterval']				= NULL;
	$CfgDaten["yAxis"][$Ai]['min']							= NULL;
	$CfgDaten["yAxis"][$Ai]['max']							= NULL;
	$CfgDaten["yAxis"][$Ai]['offset']						= NULL;
	$CfgDaten["yAxis"][$Ai]['labels']['formatter']  	= "@function() { return Highcharts.dateFormat('%H:%M', this.value) + ' Uhr' }@";
	$CfgDaten["yAxis"][$Ai]['type']							= 'datetime';
	$CfgDaten["yAxis"][$Ai]['maxZoom']						= 10 * 60 * 1000;

	$CfgDaten["yAxis"][$Ai]['labels']['style']['color']= $Farb_Array['Sonnenstand'];
   $CfgDaten["yAxis"][$Ai]['title']['style']['color']	= $CfgDaten["yAxis"][$Ai]['labels']['style']['color'];


// Chart-Optionen ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	// Chart-Config "Credits" by RS
	$CfgDaten['credits']['enabled'] 							= true;
	$CfgDaten['credits']['href'] 								= "";
	$CfgDaten['credits']['text'] 								= "www.raketenschnecke.net";
	$CfgDaten['credits']['position']['align'] 			= "right";
	$CfgDaten['credits']['position']['x'] 					= -10;
	$CfgDaten['credits']['position']['verticalAlign'] 	= "top";
	$CfgDaten['credits']['position']['y'] 					= 15;

	// Chart Zoom Option
	$CfgDaten['chart']['zoomType']        	           = "x";
	$CfgDaten['loading']['showDuration']  	           = 200;

	// exporting
	$CfgDaten['exporting']['enabled'] 						= false;
	$CfgDaten['navigation']['enabled'] 						= false;

	// plotOptions
	$CfgDaten['plotOptions']['column']['borderColor']	= "#666666";
	$CfgDaten['plotOptions']['column']['borderWidth']	= 1;
	$CfgDaten['plotOptions']['column']['shadow']			= true;
	$CfgDaten['plotOptions']['column']['pointPadding']	= -0.5;
	$CfgDaten['plotOptions']['column']['groupPadding']	= 0.2;
	$CfgDaten['plotOptions']['pie']['borderColor']		= "#333333";
	$CfgDaten['plotOptions']['pie']['borderWidth']		= 0;

	// lang
	$CfgDaten['lang']['decimalPoint']						= ",";
	$CfgDaten['lang']['thousandsSep']						= ".";
	$CfgDaten['lang']['rangeSelectorZoom']					= "";

	// Legend
	$CfgDaten['legend']['enabled']							= true;
	$CfgDaten['legend']['align']								= "right";
	$CfgDaten['legend']['shadow']								= true;
	$CfgDaten['legend']['floating']							= true;
	$CfgDaten['legend']['y']									= -312;   // -37
	$CfgDaten['legend']['x']									= -20;

	// Range Selctor
	$CfgDaten['rangeSelector']['selected']					= 4;
	$CfgDaten['rangeSelector']['inputEnabled']			= false;

	// Scrollbar
	$CfgDaten['scrollbar']['enabled']						= false;

	// Navigator
	$CfgDaten['navigator']['enabled']						= true;
	$CfgDaten['navigator']['baseSeries']					= 0;
	$CfgDaten['navigator']['height']							= 30;
	$CfgDaten['navigator']['margin']							= 10;
   $CfgDaten['navigator']['maskFill']						= "rgba(190,190,190, 0.7)";
   $CfgDaten['navigator']['series']['type']           = "areaspline";
   $CfgDaten['navigator']['series']['color']          = '#4B4B4B';
   $CfgDaten['navigator']['series']['fillOpacity']    = 0.6;
   $CfgDaten['navigator']['series']['dataGrouping']['smoothed']    = true;
   $CfgDaten['navigator']['series']['lineWidth']	   = 0;

	// Chart-Optionen "Tooltip"
   $CfgDaten['tooltip']['useHTML'] 							= true;
   $CfgDaten['tooltip']['shared'] 							= true;
   $CfgDaten['tooltip']['crosshairs'][] 					= array('width' =>1,'color' =>'grey','dashStyle'=>'dashdot' );
	$CfgDaten['tooltip']['crosshairs'][] 					= array('width' =>1,'color' =>'grey','dashStyle'=>'dashdot' );
	$CfgDaten['tooltip']['formatter'] 						= "@function() {
                                                               var s;
																					s += '<table width=\"200\" cellspacing=\"0\" cellpadding=\"0\">';
																					s += 	'<tr><td colspan= 2><b>' + Highcharts.dateFormat('%A, %d.%m.%Y', this.x) + '</b></td></tr>';

                                   										$.each(this.points, function(i, point) {
                                   										var unit =
																				{
																					'".@$CfgDaten['Series'][0]['Name']."': '".@$CfgDaten['Series'][0]['Unit']."',
																					'".@$CfgDaten['Series'][1]['Name']."': '".@$CfgDaten['Series'][1]['Unit']."',
																					'".@$CfgDaten['Series'][2]['Name']."': '".@$CfgDaten['Series'][2]['Unit']."',
																					'".@$CfgDaten['Series'][3]['Name']."': '".@$CfgDaten['Series'][3]['Unit']."',
																					'".@$CfgDaten['Series'][4]['Name']."': '".@$CfgDaten['Series'][4]['Unit']."',
																					'".@$CfgDaten['Series'][5]['Name']."': '".@$CfgDaten['Series'][5]['Unit']."',
																					'".@$CfgDaten['Series'][6]['Name']."': '".@$CfgDaten['Series'][6]['Unit']."',
																					'".@$CfgDaten['Series'][7]['Name']."': '".@$CfgDaten['Series'][7]['Unit']."',
																					'".@$CfgDaten['Series'][8]['Name']."': '".@$CfgDaten['Series'][8]['Unit']."',
																					'".@$CfgDaten['Series'][9]['Name']."': '".@$CfgDaten['Series'][9]['Unit']."',
																					'".@$CfgDaten['Series'][10]['Name']."': '".@$CfgDaten['Series'][10]['Unit']."',
																					'".@$CfgDaten['Series'][11]['Name']."': '".@$CfgDaten['Series'][11]['Unit']."',
																					'".@$CfgDaten['Series'][12]['Name']."': '".@$CfgDaten['Series'][12]['Unit']."',
																					'".@$CfgDaten['Series'][13]['Name']."': '".@$CfgDaten['Series'][13]['Unit']."',
																					'".@$CfgDaten['Series'][14]['Name']."': '".@$CfgDaten['Series'][14]['Unit']."',
																					'".@$CfgDaten['Series'][15]['Name']."': '".@$CfgDaten['Series'][15]['Unit']."',
																					'".@$CfgDaten['Series'][16]['Name']."': '".@$CfgDaten['Series'][16]['Unit']."',
																					'".@$CfgDaten['Series'][17]['Name']."': '".@$CfgDaten['Series'][17]['Unit']."',
																					'".@$CfgDaten['Series'][18]['Name']."': '".@$CfgDaten['Series'][18]['Unit']."',
																					'".@$CfgDaten['Series'][19]['Name']."': '".@$CfgDaten['Series'][19]['Unit']."',
																					'".@$CfgDaten['Series'][20]['Name']."': '".@$CfgDaten['Series'][20]['Unit']."',
																					'".@$CfgDaten['Series'][21]['Name']."': '".@$CfgDaten['Series'][21]['Unit']."',
																					'".@$CfgDaten['Series'][22]['Name']."': '".@$CfgDaten['Series'][22]['Unit']."',
																					'".@$CfgDaten['Series'][23]['Name']."': '".@$CfgDaten['Series'][23]['Unit']."',
																					'".@$CfgDaten['Series'][24]['Name']."': '".@$CfgDaten['Series'][24]['Unit']."',
																					'".@$CfgDaten['Series'][25]['Name']."': '".@$CfgDaten['Series'][25]['Unit']."',
																					'".@$CfgDaten['Series'][26]['Name']."': '".@$CfgDaten['Series'][26]['Unit']."',
																					'".@$CfgDaten['Series'][27]['Name']."': '".@$CfgDaten['Series'][27]['Unit']."',
																					'".@$CfgDaten['Series'][28]['Name']."': '".@$CfgDaten['Series'][28]['Unit']."',
																					'".@$CfgDaten['Series'][29]['Name']."': '".@$CfgDaten['Series'][29]['Unit']."',
																				}
                                    									[this.series.name];

                                    									s += '<td>' + point.series.name + ': </td><td align=right><span style=color:' + this.series.color + '><b>'
								 															+ Highcharts.dateFormat('%H:%M', this.y) + unit + '</b></span></td>';
																					s += '</tr>';

                                   										});
                        													s += '</table>';
                                   										return s;
                               											}
                   															@";

	// Highcharts-Theme
	$CfgDaten['HighChart']['Theme']			="gray.js";   // von Highcharts mitgeliefert: dark-green.js, dark-blue.js, gray.js, grid.js
	//$CfgDaten['HighChart']['Theme']				="rs_net.js";   // IPS-Theme muss per Hand in in Themes kopiert werden....


	// Abmessungen des erzeugten Charts
	$CfgDaten['HighChart']['Width'] 				= 0; 	// in px,  0 = 100%
	$CfgDaten['HighChart']['Height'] 			= 400; 	// in px

	// -------------------------------------------------------------------------------------------------------------------------------------
	// und jetzt los ......
	$s=IPS_GetScript($CfgDaten["HighChartScriptId"]);      // Id des Highcharts-Scripts
	include($s['ScriptFile']);

   //$Archiv_Path   = '\HCtmpFiles\Archiv\2012\04';
	//$tmpFilename = IPS_GetKernelDir() . "webfront\user\Highcharts".$Archiv_Path."\HighChartsCfg".$CfgDaten["HighChartScriptId"]."tmp";
  	// => ab V1.0003
  	// hier werden die CfgDaten geprft und bei Bedarf vervollstndigt
	$CfgDaten = CheckCfgDaten($CfgDaten);

	// => ab V1.0003 neu, ab V1.0006 Erweiterung Parameter "popup"
	if (isset($CfgDaten["RunMode"])
		&& ($CfgDaten["RunMode"] == "script" || $CfgDaten["RunMode"] == "popup"))
	{
		// Variante1: bergabe der ScriptId. Daten werden beim Aufruf der PHP Seite erzeugt und direkt bergeben. Dadurch kann eine autom. Aktualisierung der Anzeige erfolgen
		if ($_IPS['SENDER'] != "WebInterface")
		{
			WriteContentWithScriptId ($CfgDaten, $_IPS['SELF']);     	// und jetzt noch die ContentTextbox
			return;                                               // Ende, weil durch die Zuweisung des Script sowieso nochmals aufgerufen wird
		}

		$sConfig = CreateConfigString($CfgDaten);             	// erzeugen und zurckgeben des Config Strings
	}
	else
	{
		//Variante2: bergabe des Textfiles. Daten werden in tmp-File gespeichert. Eine automatische Aktualisierung beim Anzeigen der Content-Textbox erfolgt nicht
		$sConfig = CreateConfigString($CfgDaten);             // erzeugen und zurckgeben des Config Strings

		//$tmpFilename = CreateConfigFile($sConfig, $_IPS['SELF']);            // und ab damit ins tmp-Files

		// Archiv-Ordner und Filename vorgeben
		$path 				= "webfront/user/".$CfgDaten['Ips']['ChartType']."/tmpFiles/";
		$filename 			= "HighChartsCfg".$_IPS['SELF'].".tmp";

		// Ordner anlegen, wenn nicht vorhanden
		$Dir_String_last_Month 		= IPS_GetKernelDir().$path ;
		if (!is_dir($Dir_String_last_Month))
		mkdir ($Dir_String_last_Month  , 0777, true);

		// .tmp-File in Archivordner schreiben
		$tmpFilename 		= CreateConfigFileByPathAndFilename($sConfig, $path, $filename);  // und ab damit ins tmp-Files
		if ($_IPS['SENDER'] != "WebInterface")
		{
			WriteContentWithFilename ($CfgDaten, $tmpFilename);        // und jetzt noch die ContentTextbox
		}
	}
?>
